import { Event, Node as Step, Scope, Store } from 'effector';
import { Strategy } from './strategy';
import { CancellablePromise, createRunning } from './promise';
import { CancelledPayload, FinallyPayload } from './types';
interface RunnerScope<Payload, Done, Fail> {
    readonly finally: Event<FinallyPayload<Payload, Done, Fail>>;
    readonly strategy: Strategy;
    readonly feedback: boolean;
    readonly limit: number;
    readonly timeout?: number;
    readonly cancelled: Event<CancelledPayload<Payload>>;
    readonly cancel: Event<void>;
    readonly running: CancellablePromise<any>[];
    readonly inFlight: Store<number>;
    readonly anyway: Event<any>;
    readonly push: ReturnType<typeof createRunning>['push'];
    readonly unpush: ReturnType<typeof createRunning>['unpush'];
    readonly cancelAll: ReturnType<typeof createRunning>['cancelAll'];
    readonly $running: ReturnType<typeof createRunning>['$running'];
    readonly scope: Scope;
}
export declare const patchRunner: <Payload, Done, Fail>(runner: Step, runnerScope: RunnerScope<Payload, Done, Fail>) => void;
export {};
